#2261 closed defect (fixed)

Add coverage report generation support to rtems-tools

Reported by: Joel Sherrill Owned by:
Priority: normal Milestone: 5.1
Component: unspecified Version: 5
Severity: normal Keywords:
Cc: Blocked By:
Blocking:

Description (last modified by Joel Sherrill)

This ticket is to capture the current state of the project started by
Krzysztof Mięsowicz <krzysztof.miesowicz@…>. The goals of the project were to:

  • replace the existing shell scripts in rtems-testing with Python code integrated into rtems-tools
  • add the capability to generate a report per directory. This is important because a large body of code with low coverage negatively impacts the overall coverage area and makes reports harder to read. Breaking the reports down by functional area lets us do coverage reporting on more code even when some of the areas are in need of testing improvement.

The remaining effort in conjunction with other activity related to coverage such as inclusion of gcov generated reports is a good "summer of code" type project. This is an important capability to add to the rtems-tools.

The attached tar file krzy-patches.tar.bz2 contains the current code. There may be other issues to resolve but writing from memory, the following are the highest priority ones:

  • no default setting for coverage enable/disable
  • configuration file has hard coded paths. This should be able to be a template which is adjusted by the tools at run-time.
  • variable naming and coding style does not match that used in other Python code in rtems-tools

Krzysztof wrote some in his blog about this (http://kmiesowicz.blogspot.com/p/esa-socis-2014.html). Ensure that your base RTEMS tools are built with the RTEMS Source Builder and check on the development list if it builds a qemu with coverage support. This may have changed since he blogged.

Attachments (1)

krzy-patches.tar.bz2 (16.9 KB) - added by Joel Sherrill on Feb 11, 2015 at 3:43:33 PM.
Patches for rtems-tools to add current coverage support

Download all attachments as: .zip

Change History (7)

Changed on Feb 11, 2015 at 3:43:33 PM by Joel Sherrill

Attachment: krzy-patches.tar.bz2 added

Patches for rtems-tools to add current coverage support

comment:1 Changed on Feb 11, 2015 at 3:46:37 PM by Joel Sherrill

Description: modified (diff)

comment:2 Changed on Feb 11, 2015 at 5:55:01 PM by Joel Sherrill

Milestone: 5.0

comment:3 Changed on Feb 11, 2015 at 6:06:46 PM by Amar Takhar

I think this should be added into the waf build rather than kept separately. The test suite is inside RTEMS it seems natural everything needed for coverage reporting is there too.

I know this requires modified tools -- RSB can build the tools the rest should go into waf.

comment:4 Changed on Aug 13, 2017 at 11:52:30 PM by Chris Johns

Milestone: 5.04.12.0
Version: 4.114.12

Moving to 4.12.0 as a milestone. The ticket can be updated once this years GSoC project wraps up.

comment:5 Changed on Oct 12, 2017 at 2:51:36 AM by Joel Sherrill

Resolution: fixed
Status: newclosed

All code is now merged after GSoC.

comment:6 Changed on Nov 9, 2017 at 6:27:14 AM by Sebastian Huber

Milestone: 4.12.05.1

Milestone renamed

Note: See TracTickets for help on using tickets.